Skip to main content
GET
/
quotes
/
multi-source
Get quotes from all source chains to destination
curl --request GET \
  --url https://api.chainrails.io/api/v1/quotes/multi-source \
  --header 'Authorization: Bearer <token>'
{
  "destinationChain": "ARBITRUM_TESTNET",
  "quotes": [
    {
      "sourceChain": "BASE_TESTNET",
      "destinationChain": "ARBITRUM_TESTNET",
      "totalFee": "18000",
      "totalFeeFormatted": "0.018",
      "bridge": "CCTP",
      "paymentOptions": [
        {
          "token": "USDC",
          "tokenAddress": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913",
          "depositAmount": "1518000",
          "depositAmountFormatted": "1.518",
          "slippage": 0
        }
      ]
    }
  ],
  "cheapestOption": {
    "sourceChain": "ARBITRUM_TESTNET",
    "destinationChain": "ARBITRUM_TESTNET",
    "totalFee": "10000",
    "totalFeeFormatted": "0.01",
    "bridge": null,
    "paymentOptions": [
      {
        "token": "USDC",
        "tokenAddress": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913",
        "depositAmount": "1010000",
        "depositAmountFormatted": "1.01",
        "slippage": 0
      }
    ]
  }
}

Authorizations

Authorization
string
header
required

Enter your Chainrails API key as a Bearer token

Query Parameters

destinationChain
enum<string>
required

Destination blockchain where Alice wants to send money

Available options:
ARBITRUM_MAINNET,
ARBITRUM_TESTNET,
AVALANCHE_MAINNET,
AVALANCHE_TESTNET,
BASE_MAINNET,
BASE_TESTNET,
STARKNET_MAINNET,
STARKNET_TESTNET,
BSC_MAINNET,
ETHEREUM_MAINNET,
ETHEREUM_TESTNET,
OPTIMISM_MAINNET,
OPTIMISM_TESTNET,
MONAD_MAINNET,
MONAD_TESTNET,
POLYGON_MAINNET,
HYPEREVM_MAINNET,
LISK_MAINNET
amount
string
required

Amount in human readable format (supports decimals, e.g., "1.5", "100", "0.001")

Example:

"1.5"

tokenOut
string
required

Output token address

Example:

"0x06eFdBFf2a14a7c8E15944D1F4A48F9F95F663A4"

recipient
string

Optional recipient address

Example:

"0x742d35Cc6635C0532925a3b8D62A7fe7B58123D1"

excludeChains
string

Comma-separated chains to exclude from results

Example:

"BASE_TESTNET,OPTIMISM"

Response

Multi-source quotes retrieved successfully

destinationChain
string

Target destination chain

Example:

"ARBITRUM_TESTNET"

quotes
object[]

Quotes from all possible source chains (same-chain listed first, then sorted by cost)

cheapestOption
object

The cheapest option among all source chains (based on totalFee)